import agentes_ejemplos.*;
import Core.Platform;
import EjemploVRS.Pizarra;
import EjemploVRS.Point;

/*
 * Creado el 19-abr-2005
 *
 * TODO Para cambiar la plantilla de este archivo generado, vaya a
 * Ventana - Preferencias - Java - Estilo de código - Plantillas de código
 */

/**
 * @author root
 *
 * TODO Para cambiar la plantilla de este comentario generado, vaya a
 * Ventana - Preferencias - Java - Estilo de código - Plantillas de código
 */

public class Main {
	
	private static void error(Exception e) 
	{
	     System.out.print("Error en la entrada: ");
	     System.out.println(e);
	     System.exit(-1);
	}

	public static void main(String args[]) 
	{
	    int num_args = args.length;
	    boolean Debug=false,Kiwi=false,Verbose=false;
	    
	    switch(num_args)
		{
	    	case 1:
	    	{
	    		if (args[0].compareTo("-d")==0 || args[0].compareTo("-debug")==0)
	    		{
	    			System.out.println("Se ha seleccionado la opcion de depuracion");
	    			Debug = true;
	    		}
	    		else if (args[0].compareTo("-k")==0 || args[0].compareTo("-kiwi")==0)
	    		{
	    			Kiwi=true;
	    			System.out.println("Se ha seleccionado la opcion de kiwi");
	    		}
	    		else if (args[0].compareTo("-v")==0 || args[0].compareTo("-verbose")==0)
	    		{
	    			Verbose=true;
	    			System.out.println("Se ha seleccionado la opcion de Verbose");
	    		}
	    		else 
	    		{
	    			System.out.println("Argumento no valido");
	    		}
	    	break;	
	    	}
	    	case 2:
	    	{
	    		int i=0;
	    		while (i<2)
	    		{
		    		if (args[i].compareTo("-d")==0 || args[i].compareTo("-debug")==0)
		    		{
		    			Debug = true;
		    			System.out.println("Se ha seleccionado la opcion de Debug");
		    		}
		    		else if (args[i].compareTo("-k")==0 || args[i].compareTo("-kiwi")==0)
		    		{
		    			Kiwi=true;
		    			System.out.println("Se ha seleccionado la opcion de Kiwi");
		    		}
		    		else if (args[i].compareTo("-v")==0 || args[i].compareTo("-verbose")==0)
		    		{
		    			Verbose=true;
		    			System.out.println("Se ha seleccionado la opcion de Verbose");
		    		}
		    		else 
		    		{
		    			System.out.println("Argumento no valido");
		    		}
		    		i++;
	    		}
	    		break;	
	    	}
	    	case 3:
	    	{
	    		int i=0;
	    		while (i<3)
	    		{
		    		if (args[i].compareTo("-d")==0 || args[i].compareTo("-debug")==0)
		    		{
		    			Debug = true;
		    			System.out.println("Se ha seleccionado la opcion de Debug");
		    		}
		    		else if (args[i].compareTo("-k")==0 || args[i].compareTo("-kiwi")==0)
		    		{
		    			Kiwi=true;
		    			System.out.println("Se ha seleccionado la opcion de Kiwi");
		    		}
		    		else if (args[i].compareTo("-v")==0 || args[i].compareTo("-verbose")==0)
		    		{
		    			Verbose=true;
		    			System.out.println("Se ha seleccionado la opcion de Verbose");
		    		}
		    		else 
		    		{
		    			System.out.println("Argumento no valido");
		    		}
		    		i++;
	    		}
	    		break;	
	    	}
	    	default:
	    	{
	    		System.out.println("Demasiados argumentos");
	    		break;
	    	}
		}
	    
	    if (Verbose) System.out.println("creando instancia de la plataforma...");
	    
	     Platform platform = new Platform(Debug,Kiwi,Verbose);
  
         Pizarra pizarra = new Pizarra();	     
	     pizarra.setPuntoInicial(new Point(0.0,0.0));
		 pizarra.setPuntoFinal(new Point(0.0,0.0));	 	
		 pizarra.AddPuntoObjeto(new Point(3000.0,5000.0));
		 pizarra.AddPuntoObjeto(new Point(6000.0,3000.0));
		 pizarra.AddPuntoObjeto(new Point(8000.0,10000.0));
		 pizarra.AddPuntoObjeto(new Point(5000.0,14000.0));
		 pizarra.setPuntoActual(new Point(0.0,0.0));
		
		 if (Verbose) System.out.println("creando agentes...");
		 
	     AgenteControlador agente1=new AgenteControlador(platform,"AgenteControlador",pizarra);
	     agente1.start();
	    
	     AgentePlanificador agente2=new AgentePlanificador(platform,"AgentePlanificador",pizarra);
	     agente2.start();
	     
	     AgenteRecolector agente3=new AgenteRecolector(platform,"AgenteRecolector",pizarra);
	     agente3.start();
	     
	     AgenteSensorizador agente4 = new AgenteSensorizador(platform,"AgenteSensorizador",pizarra);
	     agente4.start();
	     
    } //end main
}
